VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "La grenouille et l'escalier"
   ClientHeight    =   3540
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4560
   Icon            =   "Form1.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3540
   ScaleWidth      =   4560
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame Frame2 
      Caption         =   "Rsultats (Click pour explications...)"
      Height          =   1215
      Left            =   120
      MousePointer    =   14  'Arrow and Question
      TabIndex        =   4
      Top             =   2160
      Width           =   4335
      Begin VB.Label lblBarbare 
         Caption         =   "v"
         Height          =   255
         Left            =   1560
         TabIndex        =   7
         Top             =   360
         Width           =   1815
      End
      Begin VB.Label lblBogosse 
         Caption         =   "A la Bogosse :"
         Height          =   255
         Left            =   480
         MousePointer    =   14  'Arrow and Question
         TabIndex        =   6
         Top             =   720
         Width           =   3495
      End
      Begin VB.Label Label3 
         Caption         =   "A la Barbare :"
         Height          =   255
         Left            =   480
         MousePointer    =   14  'Arrow and Question
         TabIndex        =   5
         Top             =   360
         Width           =   1095
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "Configuration de Base"
      Height          =   1935
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   4335
      Begin VB.CommandButton Command2 
         Caption         =   "A la Bogosse"
         Height          =   495
         Left            =   2280
         TabIndex        =   8
         Top             =   1080
         Width           =   1335
      End
      Begin VB.CommandButton Command1 
         Caption         =   "A la Barbare"
         Height          =   495
         Left            =   720
         TabIndex        =   3
         Top             =   1080
         Width           =   1335
      End
      Begin VB.TextBox txtBarreaux 
         Height          =   285
         Left            =   2760
         TabIndex        =   2
         Text            =   "4"
         Top             =   480
         Width           =   615
      End
      Begin VB.Label Label1 
         Caption         =   "Nombre de marches de l'escalier :"
         Height          =   255
         Left            =   240
         TabIndex        =   1
         Top             =   540
         Width           =   2415
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Public Combinaisons As Long     'Cumul du nombre de combinaisons (A la Barbare)
Public LastCalcul As Integer    'Nbre de barreaux du dernier Calcul
Public StopIt As Boolean        'Pour stopper un calcul a la Barbare
Public Calculating As Boolean   'En train de Calculer (Mode A la Barbare)

Private Sub Command1_Click()
'CALCUL A LA BARBARE (PAR RECURRENCE)

If Calculating Then
    StopIt = True
    Calculating = False
    Exit Sub
End If

If txtBarreaux.Text = "" Then
    Exit Sub
End If

'Avertissement si le calcul risque de prendre trop de temps
If txtBarreaux.Text > 25 Then
    Reponse% = MsgBox("Attention ! Le calcul prendra " & Round(ALaBogosse(txtBarreaux.Text) / 121393, 1) & _
    " fois plus de temps que pour 25 barreaux !" & vbCrLf & "Voulez vous Continuer ?", _
    vbExclamation + vbYesNo, "Attention ton PC va cramer")
    If Reponse% = vbNo Then
        Exit Sub
    End If
End If

Calculating = True
StopIt = False
Command1.Caption = "STOP !"
Combinaisons = 0

If LastCalcul <> txtBarreaux.Text Then
    LastCalcul = txtBarreaux.Text
    lblBarbare.Caption = ""
    lblBogosse.Caption = "A la Bogosse : "
End If

'Dbut Rcurrence
Sauter 1, "", 0
Sauter 2, "", 0
'Fin Rcurrence

lblBarbare.Caption = Combinaisons & " combinaisons"

Calculating = False
Command1.Caption = "A la Barbare"
End Sub

Private Sub Sauter(Nbre As Integer, Anciens As String, Total As Integer)
'Procdure rcurrente pour le calcul A la Barbare
Dim a As Integer
Dim chaine As String

'Possibilit de stopper un calcul en cours
If StopIt Then
    Exit Sub
End If

a = Total + Nbre
If a = txtBarreaux.Text Then
    'Nouvelle combinaison dtecte
    Combinaisons = Combinaisons + 1
    lblBarbare.Caption = Combinaisons
    DoEvents
    Exit Sub
ElseIf a > txtBarreaux.Text Then
    Exit Sub
End If

'Cration progressive de la chaine (Au dpart je voulais afficher les combinaisons dans
'un controle ListBox mais ce dernier admet au maximum 32000 entres, ce qui est largement
'insuffisant pour afficher les combinaisons pour une chelle de 25 barreaux...
chaine = Anciens & Trim(Str(Nbre))

'On continue la rcurrence
Sauter 1, chaine, a
Sauter 2, chaine, a

End Sub

Private Sub Command2_Click()
Dim n As Integer

If txtBarreaux.Text = "" Then
    Exit Sub
End If

n = txtBarreaux.Text
If LastCalcul <> n Then
    LastCalcul = n
    lblBarbare.Caption = ""
    lblBogosse.Caption = "A la Bogosse : "
End If

lblBogosse.Caption = "A la Bogosse : " & ALaBogosse(n) & " combinaisons"

End Sub

Private Function Factorielle(n As Integer)
'Calcule la factorielle d'un nombre (n < 171)
Dim res As Double
res = 1

For a = n To 1 Step -1
    res = res * a
Next
Factorielle = res
End Function

Private Sub Form_Load()
lblBarbare.Caption = ""
Form1.Left = (Screen.Width - Form1.Width) / 2
Form1.Top = (Screen.Height - Form1.Height) / 2
End Sub

Private Sub Frame2_Click()
Dim s As String
s = App.Path & "\Explications.htm"
Shell "C:\Program Files\Internet Explorer\IEXPLORE.EXE " & s, 1
End Sub

Private Sub Label3_Click()
Dim s As String
s = App.Path & "\Explications.htm"
Shell "C:\Program Files\Internet Explorer\IEXPLORE.EXE " & s, 1
End Sub

Private Sub lblBogosse_Click()
Dim s As String
s = App.Path & "\Explications.htm"
Shell "C:\Program Files\Internet Explorer\IEXPLORE.EXE " & s, 1
End Sub

Public Function ValideFrappe(box As TextBox, KeyAscii As Integer)
'Controle de Frappe, on n'accepte que les chiffres
Select Case KeyAscii
Case 8, 48 To 57
Case Else
    KeyAscii = 0
End Select
ValideFrappe = KeyAscii
End Function

Private Sub txtBarreaux_KeyPress(KeyAscii As Integer)
'Controle de Frappe
KeyAscii = ValideFrappe(txtBarreaux, KeyAscii)
End Sub

Public Function ALaBogosse(n As Integer)
'Mthode 2 : A La Bogosse (Voir "Explications.htm")

Dim Max2 As Integer
Dim Nbre2 As Integer
Dim Nbre1 As Integer
Dim Total As Integer
Dim Combos As Double

Combos = 1

Max2 = Int(n / 2)
For a = 1 To Max2
    Nbre2 = a
    Nbre1 = n - 2 * a
    Total = n - a
    Combos = Combos + Factorielle(Total) / (Factorielle(Nbre1) * Factorielle(Nbre2))
Next

ALaBogosse = Combos

End Function
